----------------------------------------------------------------
------------------------- Версия 3.2.0 -------------------------
----------------------------------------------------------------

-- Core --
- Поддержка работы без std::typeinfo.
- Исправлена неправильная работа выравнивания окон на внеэкранных слоях (например на RTT слое).
- Исправлена ошибка с изменением порядка отрисовки виджетов на одном слое.

-- Widgets --
- DDContainer: добавлен метод resetDrag для сброса состояния перетаскивания.
- TextBox: Добавлены опциональные тени для текста.
- EditBox: исправлено неправильное отображение при высоте виджета меньшем чем высота шрифта.
- EditBox: добавлен сброс Redo при изменении текста пользователем.
- Canvas: исправлено некорректное удаление.
- ProgressBar: исправлена ошибка с некорректным отображением после растягивания.

--SubWidgets--
- RotatingSkin: Исправлен саб виджет (неправильные UV координаты).

-- Resources --
- ResourceTrueTypeFont:
   * Уменьшено использование памяти для текстуры (обычно на 50% или больше).
   * Улучшена скорость создания и работы со шрифтами.
   * Добавлена поддержка Windows FON/FNT растровых шрифтов и встроенных SBIT растровых в TrueType шрифтах.
   * Доавлена поддержка расширенных метрик символов, типографически корректный межстрочный интервал и перекрывающиеся символы; например "fj".
   * Реализована возможность выбрать символ используемый для отсутствующих символов (по умолчанию используется символ из шрифта (обычно квадратик) вместо пробела).
   * Реализовано непопиксельное позиционирование.
   * Добавлены удобные значение по умолчанию для различный свойств.
   * Некоторые старые свойста оставлены, но являются устаревшими.
   * Исправлена проблема с использованием whitespace символов, отличных от символа пробела и табуляции.
   * Исправлены некоторые утечки и падения.
   * Если шрифт не может быть загружен, то вместо Assert'а ошибка просто логируется.
- ResourceManualFont:
   * Доавлена поддержка расширенных метрик символов и перекрывающихся символов; например "fj".
   * Доавлена возможность выбрать символ используемый для отсутствующих символов.

-- Wraps --
- BaseLayout корректно работает без макетов и\или виджетов

-- Plugins --
- Обновлен плагин BerkeliumWidget

-- Tools --
- Исправлены различные баги и неточностей в LayoutEditor
- FontViewer
   * Добавлена поддержка нового функционала ResourceTrueTypeFont and ResourceManualFont.
   * Добавлена поддержка типов шрифтов: *.ttc, *.otf, *.pfa, *.fon, and *.fnt.
   * Изменен интерфейс.
   * Реализована автоматическая генерация имен файлов при сохранении.
   * Исправлены некоторые утечки и падения.

-- Platforms --
- GUI c Ogre не становится wireframe после установки wireframe режима отрисовки
- Исправлена платформа OpenGL (Очистка буферов)
- Добавлена тестовая платформа DirectX 11

----------------------------------------------------------------
------------------------- Версия 3.2.0 RC1 ---------------------
----------------------------------------------------------------

-- Core --
- Упрощены свойства скинов для более удобного создания в редакторе.
- Все события у виджетов теперь мультиделегаты.
- Поддержка драг правой кнопкой мыши.
- В лог, помимо версии, теперь пишется ревизия (если собирать версии из svn).
- В шрифтах теперь проверяется текстура при создании.
- Другие незначительные дополнения и багфиксы.

-- Managers --
- LanguageManager теперь заменяет теги рекурсивно.
- Исправлен баг в LanguageManager с выбором несуществующего языка.

-- Resources --
- Добавлен ресурс леаутов, лейауты грузятся и парсятся только при первой загрузке, а последующие - из памяти.
- Все ресурсы core имеют приставку "MyGUI_" для предотвращения конфликтов имен.

-- Widgets --
- VScroll и HScroll заменены на один класс ScrollBar.
- Edit переименован в EditBox.
- List переименован в ListBox.
- MenuCtrl переименован в MenuControl.
- MultiList переименован в MultiListBox.
- Progress переименован в ProgressBar.
- StaticImage переименован в ImageBox.
- StaticText переименован в TextBox.
- Tab переименован в TabControl.
- В Window добавлено свойство Moveable.
- Message перенесен из коре в Common.
- MultiListBox поддерживает различные режимы автоматического ресайза колонок.
- В Button вместо свойств StateCheck и ButtonPressed одно свойство StateSelected.
- ListBox и ComboBox поддерживают ToolTip.
- Пункт меню теперь можно отмечать. будет появляться галочка.
- Свойство AlignVert переименовано VerticalAlignment.
- При скрытии виджет теряет ввод и активность.
- Отображение активных элементов в списке теперь правильно реагируют на изменения в списке (удаление\добавление).
- Свойства связанные с текстом перенесенны из Widget в TextBox.

--SubWidgets--
- Удален сабвиджет RawRect, т.к. у Widget появилось свойсво Colour.
- Добавлен сабвиджет FilterNoneSkin который не сглаживает текстуру при растягивании (Ogre).
- Добавлен сабвиджет PolygonalSkin для рисования линий.

-- Tools --
- Добавлен SkinEditor.
- Все скины полностью созданы в SkinEditor.
- В LayoutEditor добавленна поддержка создания проектов.
- В LayoutEditor теперь можно создавать колонки в MultiListBox.
- В LayoutEditor теперь можно создавать PopupMenu\MenuBar.
- В LayoutEditor добавлено окно выбора цвета.
- В LayoutEditor выравнивание по сетке относительно отца.
- В LayoutEditor показывается препросмотр скина.
- В LayoutEditor поддерживается масштаб.
- В LayoutEditor возможно изменять тип Widget.
- В LayoutEditor есть возможность создавать свои уникальные свойства и с ними работать.
- LayoutEditor не проверяется уникальность имени Widget.
- FontViewer теперь сохраняет сгенереный шрифт в двух форматах. Как описание для генерации и как ручной шрифт без использрвания TrueType (текстура + описание глифов).

-- Platforms --
- В OpenGL и DirectX BasisManager теперь правильно отображает содержимое W32 окна.
- В OpenGL и DirectX исправлена утечка в DataManager.
- В OpenGL добавлено сохранение текстуры.
- Исправлена опечатка vertext -> vertex.

-- Plugins --
- Удален Awesomium plugin (он теперь не LGPL).

-- UnitTests --
- Добавлен UnitTest для PolygonalSkin.
- Добавлен UnitTest для RotatingSkin.

-- CMake --
- Добавлена опция MYGUI_CHECK_MEMORY_LEAKS для обнаружения утечек памяти.
- Добавлена опция MYGUI_USE_PROJECT_FOLDERS для разбиения проектов студии по папкам в решении.
- Переименованы настройки для UnitTest и Demos.
- Теперь W32 ввод указан по умолчанию (ранее был OIS).


----------------------------------------------------------------
------------------------- Версия 3.0.1 -------------------------
----------------------------------------------------------------
-- License --
- в LGPL добавлено исключение для статической линковки открывающее возможность использования MyGUI в закрытых приложениях без нарушения лицензии (например на iPhone)
- все содержимое Media за исключением нескольких файлов, созданных не командой разработчиков MyGUI теперь имеет MIT лицензию

-- Core --
- рефакторинг кода для уменьшения вероятности возникновения ошибок (выявленные статическими анализаторами)

-- Renders --
- добавлена поддержка внешне созданных текстур в Ogre рендере (оборачивание существующих текстур)

-- Widgets --
- в Window добавлен метод getCaptionWidget для доступа к заголовку и управления его текстовым отображением (Шрифт и его размер)
- исправлен RenderBoxScene врапер
- исправлен баг с отображением Disabled, когда выджеты отображались как не Disabled

-- Managers --
- Добавлено сообщение в лог, если скин не был найден.

-- Utility --
- Исправлена загрузка несуществующих текстур для пикинга виджетов

-- Wraps --
- Добавлена настройка для генерации враперов в CMake

-- Plugins --
- AwesomiumPlugin и HikariPlugin вынесены в отдельную настройку CMake

-- Resources --
- исправлен баг с некорректным отображением шрифтов на старых видеокартах : TrueType шрифт генерит текстуру R8G8B8A8 на машинах, которые не поддерживают L8A8 (OgreRender).

----------------------------------------------------------------
------------------------- Версия 3.0.0 -------------------------
----------------------------------------------------------------
-- Core --
- рендер система отделена от ядра

-- Widgets --
- удален виджет RenderBox - и вынесен в Common как врапер
- добавлен виджет ListCtrl - базовый виджет для списков с поддержкой OwnDraw, горизонтального скрола и произвольной высоты каждой строки
- добавлен виджет ListBox - реализация списка с горизонтальным скролом на ListCtrl

-- Managers --
- добавлен менеджер FactoryManager - менеджер создает все экземпляры объектов реализующих IObject (ресурсы, виджеты, контроллеры и т.д.)
- добавлен менеджер DataManager - появилась возможность создания своего типа или источника данных

-- Controllers --
- контроллеры поддерживают десерелизацию, возможно создание через XML

-- Resources --
- добавлен тип ресурса ImageSetPointer для создания курсоров на основе ресурса ImageSet с поддержкой анимации
- добавлен тип ресурса ManualPointer для создания курсоров на основе текстуры
- добавлен тип ресурса TrueTypeFont для создания векторных шрифтов true type
- добавлен тип ресурса ManualFont для создания шрифтов на основе текстуры
- добавлен тип ресурса Skin для описания скина

--SubWidgets--
- добавлен сабвиджет RotateSkin с поддержкой вращения геометрии

-- Tools --
- Расширен LayoutEditor, поддержка контроллеров

-- Demos --
- Demo_Pointers - демонстрация контекстов курсоров и поддержки W32 курсоров
- Demo_RenderBox - демонстрация использования RenderBox врапера

-- Plugins --
- Plugin_AwesomiumWidget - демонстрация реализации плагина на основе Awesomium (html внутри виджета)
- Plugin_HikariWidget - демонстрация реализации плагина на основе Hikari (Flash внутри виджета)

-- UnitTests --
- UnitTest_Layers - демонстрация использование GUI в 3D сцене
- UnitTest_RTTLayers - демонстрация рендера леера в текстуру
- UnitTest_TextureAnimation - демонстрация RTT нода, для кеширования или анимации целого окна
- UnitTest_TreeControl - демонстрация реализации древовидного списка (автор : Pavel Turin)

----------------------------------------------------------------
------------------------- Версия 2.2.3 -------------------------
----------------------------------------------------------------

-- SubWidgets -- 
- полностью переделан саб виджет текста EditText
   * поддержка разбиения на слова при редактировании
   * поддержка курсора и выделения для ручного шрифта ManualFont

-- Widget --
- исправлена проблема с наследуемым состоянием Disabled и Visible

----------------------------------------------------------------
------------------------- Версия 2.2.2 -------------------------
----------------------------------------------------------------

-- Core --
- преобразована иерархия виджетов, добавлены стили 
   * Child - дочернее окно, обрезается по границам окна и не перекрывается (по умолчанию у дочерних)
   * Popup - всплывающее окно, имеет родителя, но не обрезается по нему, а свободно перемещается
   * Overlapped - дочернее окно, обрезается по границам родителя (если он есть), и может перекрываться (у рутовых по умолчанию)
- поддержка отсоединение и присоединение виджетов, смена скинов и смена стилей на лету
- введена быстрая система RTTI идентификация типа во время выполнения. Теперь типы виджетов можно безопасно проверять


-- Widgets --
- добавлен виджет DDContainer - базовый класс для всех виджетов имеющих дроп
- добавлен виджет MenuCtrl - базовый класс для всех меню
- добавлен виджет MenuBar
- добавлен виджет ScrllView
- Widget имеет поддержку тултипов
- StaticImage поддерживает анимацию


-- Managers --
- добавлен менеджер ResourceManager - позволяет загружать пользовательские ресурсы, для примера ImageSet
- добавлен менеджер LanguageManager - позволяет автоматически заменять теги в загружаемых лейаутах по загруженным словаря, а так же ручная вставка и замена тегов
- менеджер PointerManager - поддерживает анимированные курсоры
- менеджер FontManager - поддерживает загрузку кастомных шрифтов из текстуры


-- Controllers --
- расширенны контроллеры движения - добавился Jump


-- Resources --
- добавлен тип ресурса ImageSet позволяет создавать группы картинок, с поддержкой анимации, загружается через XML


--SubWidgets--
- добавлен сабвиджет RawRect для прямого доступа к вершинам квада
- добавлен сабвиджет TileRect для поддержки тайлинга квада


-- Others --
- все виджеты контейнеры имеют Any для хранения пользовательской информации об айтеме
- добавлено указание версии для XML
- добавлены две темы для скинов


-- Wraps --
- BaseLayout - базовая обертка, для загружаемых лейаутов
- BaseItemBox - обертка, для удобного и быстрого использования ItemBox а
- Добавлен контрол PanelView - полностью сделан на обертках

 
-- Tools --
- Расширен LayoutEditor, поддержка внешних ресурсов, для удобной интеграции с внешними проектами
- добавлен ImageSetViewer для просмотра ресурсов типа ResourceImageSet - наборы картинок с поддержкой анимации


-- Demos --
- Demo_Colour - демонстрация контрола управления цветом, RowRect сабвиджета и управление цветом текста в EditBox
- Demo_Console - демонстрация контрола консоль для управления виджетом
- Demo_Controllers - демонстрация контроллеров движения и альфы, для управления виджетами
- Demo_Font - демонстрация генерирования шрифта TrueType с возможностью сохранитьв формате MyGUI для быстрой интеграции шрифта
- Demo_Gui - демонстрация совместного использования виджетов разных стилей и типов
- Demo_ItemBox - демонстрация возможностей ItemBox, обертки BaseItemBox а так же ToolTip и внешний пользовательский ресурс, загружаемый через XML
- Demo_PanelView - демонстрация контрола на основе обертки
- Demo_Picking - демонстрация фокуса мыши по произвольному контуру
- Demo_PluginStrangeButton – демонстрация использования внешних плагинов и внешних виджетов
- Demo_ScrollView - демонстрация прокручиваемого поля
- Demo_Themes - демонстрация различных тем
- Demo_StaticImage - демонстрация простейшего вьювера ImageSet
